*" PACKAGE AADMIN !"  ᥤ롼
*"                  ver 1.00                   92/06/11 numaguti
*"                  SRC:=$GC/model/agcm5/src/admin/aadmn.F
*"                  DOC:=$GC/model/agcm5/doc/main.tex
*"   93/08/29 ݺ  PHYSICS ѹ
*"   97/09/22 Ƿ  AHSTRGλѹ. HISTRG Ƥֺݤ˥ǥե
*" ե̾񤭤(HISTRGθ6ܤΰ'CON'' ')
***********************************************************************
      PROGRAM GCM5                           !" ᥤ롼
*
*"    ¿ǥ
*"    Arakawa & Suarez ľʬ Һɸ
*"    semi implicit scheme
*"    ɸʪ, ά
*
*   [PARAM]
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻ, ȿ
      INCLUDE   (ZHDIM)                      !" ʸʸ
      INCLUDE   (ZCCOM)                      !" ɸʪ
#else
#include        "zcdim.F"                    !" ʻ, ȿ
#include        "zhdim.F"                    !" ʸʸ
#include        "zccom.F"                    !" ɸʪ
#endif
*
*   [VAR]
      REAL       GAU   ( IDIM, JDIM, KMAX )  !"   
      REAL       GAV   ( IDIM, JDIM, KMAX )  !"   
      REAL       GAT   ( IDIM, JDIM, KMAX )  !"   
      REAL       GAPS  ( IDIM, JDIM       )  !" ɽ
      REAL       GAQ   ( IDIM, JDIM, KMAX )  !" 漾  
      REAL       GAVOR ( IDIM, JDIM, KMAX )  !"   
      REAL       GADIV ( IDIM, JDIM, KMAX )  !" ȯ  
*"       : ʻǡ(t) <DYNMCS>  ʻǡ(t+t)
*
      REAL       GBU   ( IDIM, JDIM, KMAX )  !"   
      REAL       GBV   ( IDIM, JDIM, KMAX )  !"   
      REAL       GBT   ( IDIM, JDIM, KMAX )  !"   
      REAL       GBPS  ( IDIM, JDIM       )  !" ɽ
      REAL       GBQ   ( IDIM, JDIM, KMAX )  !" 漾  
      REAL       GBVOR ( IDIM, JDIM, KMAX )  !"   
      REAL       GBDIV ( IDIM, JDIM, KMAX )  !" ȯ  
      REAL       GBTG  ( IDIM, JDIM )        !" ̲٣ԣ
*"       : ʻǡ(t-t) <DYNMCS>  ʻǡ(t)
*
      REAL       GTUA  ( IDIM, JDIM, KMAX )  !" ưѲգ
      REAL       GTVA  ( IDIM, JDIM, KMAX )  !" ̱ưѲ֣
      REAL       GTH   ( IDIM, JDIM, KMAX )  !" ٻѲ  
      REAL       GTR   ( IDIM, JDIM, KMAX )  !" 漾Ѳ  
*"       : <PHYSCS> ʻѲ(P) <DYNMCS> ʻѲ(P+D)
*
      INTEGER    ISTEP                 !" ̤ƥå׿
      INTEGER    ITA                   !" ̤(t)
      INTEGER    ITB                   !" ̤(t-t)
      INTEGER    IDATEA( 6 )           !" ǯʬ
      INTEGER    IDATEB( 6 )           !" ǯʬ
      REAL       DELT                  !" ֹߦt
      REAL       DELTP                 !" ʪֹ捻t !"ݺ93/08/29ɲ 
      LOGICAL    OADVNC                !" 郎ʹԤ뤫ݤ
      LOGICAL    ORSTR                 !" ƽȯϤ뤫ݤ
*"       : 
*
*   [ONCE]
      INTEGER    ITSTRT                !" ׻ϻ
      INTEGER    ITEND                 !" ׻λ
      INTEGER    IORSTR                !" ϴֳ֡ƽȯ
*"       : ¸ѥ᡼
*
      INTEGER    IDELT                 !" ɸֹ
      INTEGER    INISTP                !" ƥå׿
      REAL       TFIL                  !" ֥ե륿
*"       : ֥ƥåץѥ᡼
*
*"    COMMON /COMCON/ ( include ZCCOM )
*     REAL       CP                    !" 絤갵Ǯ
*     REAL       EL                    !" ζŷǮ
*     REAL       ER                    !" ϵȾ
*     REAL       GRAV                  !" ϲ®
*     REAL       RAIR                  !" 絤
*     REAL       RVAP                  !" 
*     REAL       CPVAP                 !" 갵Ǯ
*     REAL       DH2O                  !" ̩
*     REAL       EPSV                  !" 絤ʬ
*     REAL       ES0                   !" ˰¾
*     REAL       STB                   !" Stefan-Boltzman
*     REAL       FKARM                 !" Karman 
*"    COMMON /COMCON/ end
*"       : ʪѥ᡼
*
      REAL       ALAT  ( JDIM )        !" 
      REAL       DLAT  ( JDIM )        !" ٲٽ
      REAL       ALON  ( IDIM )        !" 
      REAL       DLON  ( IDIM )        !" ٲٽ
      REAL       SIG   ( KMAX )        !" ҥ٥()
      REAL       SIGM  (KMAX+1)        !" ҥ٥(Ⱦ)
      REAL       DSIG  ( KMAX )        !" ()
      REAL       DSIGM (KMAX+1)        !" (Ⱦ)
*"       : ɸ
*
*   [WORK]
      COMMON    /COMWRK/ WORK
      REAL       WORK  ( NWORK )       !" ΰ
      INTEGER   I, J, K
*

      REAL  gdtphy( idim, jdim, kmax )
      REAL  gduphy( idim, jdim, kmax )
      REAL  gdvphy( idim, jdim, kmax )
      REAL  gteq( idim, jdim, kmax )
      REAL  gpp( idim, jdim, kmax )
      REAL  p0, kt, ka, ks, kf, kv, sigb, dty, dthetaz
      REAL  kappa, day

      REAL  tphy( idim, jdim, kmax )
      REAL  uphy( idim, jdim, kmax )
      REAL  vphy( idim, jdim, kmax )

      REAL       GTVOR ( IDIM, JDIM, KMAX )  !"    Ѳ
      REAL       GTDIV ( IDIM, JDIM, KMAX )  !" ȯ   Ѳ

c$$$      REAL       UVFACT ( IDIM, JDIM )       !" uU Υե

c$$$      REAL       WAVOR ( NMDIM , KMAX     )  !"   
c$$$      REAL       WADIV ( NMDIM , KMAX     )  !" ȯ  
      
      REAL       WTVOR ( NMDIM , KMAX     )  !"    Ѳ (ڥȥ)
      REAL       WTDIV ( NMDIM , KMAX     )  !" ȯ   Ѳ (ڥȥ)
      
*
*" << SETPUP :  >>
*
      CALL CLCSTR ( 'SETUP' )
      CALL YPREP                       !" ƥ 
*
      CALL SETPAR                      !" ¸ѥ᡼
     O         ( ITSTRT, ITEND , IORSTR,
     O           IDELT , INISTP, TFIL    )
*
      CALL SETCOR                      !" ɸ
     O         ( ALON  , DLON  ,
     O           ALAT  , DLAT  ,
     O           SIG   , DSIG  ,
     O           SIGM  , DSIGM  )
*
      CALL RDSTRT                      !" ͤɤ߹ߤȺ
     O         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     O           GAVOR , GADIV ,
     O           GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     O           GBVOR , GBDIV ,
     O           ITA   , ITB   , IDATEA, IDATEB, ISTEP ,
     C           ITSTRT, ALAT  , DLAT                    )
*
      CALL ADMXMN 
     I         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     I           GADIV , GAVOR , ITA   , 'start GA'      )
      CALL ADMXMN 
     I         ( GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     I           GBDIV , GBVOR , ITB   , 'start GB'      )
*
      CALL RDSTRG                      !" ɽͤɤ߹
     O         ( GBTG  ,
     I           GBT   ,
     C           ITB     )
*
      CALL SETTIM                      !" 򵭲 
     I         ( ITA   , ITB   , IDATEA, IDATEB, ISTEP  )
      CALL AHSTRG                      !" ɸʿѽϤϿ
*
      CALL CLCEND ( 'SETUP' )
*
*  << LOOP : <************* ᥤ󡦥롼 >>
*
 5000 CONTINUE
*
#ifdef DEBUG
         CALL ADMXMN 
     I         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     I           GADIV , GAVOR , ITA   , 'begin LOOP'    )
#endif
         ISTEP = ISTEP + 1
*
*     << START : ƥåפϤν >>
*
         CALL CLCSTR ( 'TIMCON' )
*
         CALL TIMSTP                   !"  
     O         ( DELT  , OADVNC, ORSTR ,
     I           ITA   , ITB   , IDATEA, IDATEB, ISTEP  ,
     C           IDELT , INISTP, ITEND , IORSTR          )
*
         CALL SAVEGB                   !" t-tΥǡ򥻡
     I         ( GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     I           GBVOR , GBDIV                           )
         CALL CLCEND ( 'TIMCON' )
*
*"    << INTEGR : ʬ >>
* 
        CALL CLCSTR ( 'PHYSCS' )   
*
         DELTP = 2 * DELT                          !" 93/08/29 ݺɲ
*
c$$$         CALL PHYSCS                   !" ʪ    93/08/29 ݺѹ  
c$$$     O         ( GTUA  , GTVA  , GTH   , GTR   , 
c$$$     M           GBTG  ,
c$$$     I           GBU   , GBV   , GBT   , GBPS  , GBQ   ,
c$$$     I           GBVOR , GBDIV , 
c$$$     I           ITB   , IDATEB, DELTP , DELT , 
c$$$     C           ALON  , ALAT  ,
c$$$     C           SIG   , SIGM  , DSIG  , DSIGM          )
*

         DO 2100 K = 1, KMAX
            DO 2100 J = 1, JMAX
               DO 2100 I = 1, IMAX
                  GTUA( I, J, K ) = 0.
                  GTVA( I, J, K ) = 0.
                  GTH( I, J, K )  = 0.
                  GTR( I, J, K )  = 0.
 2100       CONTINUE

         CALL CLCEND ( 'PHYSCS' )
*

         day = 86400.0d0
         kappa = RAIR / CP
         p0 = 1000.0d0
c$$$         p0 = 1000.0d0 * 1.0d2
         sigb    = 0.7d0
         ka      = 1.0d0 / ( 40.0d0 * day )
         ks      = 1.0d0 / ( 4.0d0 * day )
         dty     = 60.0d0
         dthetaz = 10.0d0

c$$$         DO I = 1, IDIM
c$$$            DO J = 1, JDIM
c$$$               UVFACT ( I,J ) = COS( ALAT( J ) )
c$$$            END DO
c$$$         END DO

c$$$         do j = 1, jdim
c$$$            write(*,*) 'ALAT(', j, ')=', ALAT( j )
c$$$         end do

c$$$         write(*,*) 'GBPS=', GBPS
c$$$         write(*,*) 'GAPS=', GAPS

         do k = 1, kmax
            do j = 1, jdim
               do i = 1, idim
                  gpp (i,j,k) = SIG( k ) * GBPS (i, j)
c$$$                  gpp (i,j,k) = SIG( k ) * GAPS (i, j)
c$$$                  write(*,*) 'gpp(i,j,k)/p0=', gpp( i, j, k ) / p0
               end do
            end do
         end do

         do k = 1, KMAX
            do j = 1, JDIM
               do i = 1, IDIM
                  gteq( i, j, k ) = max( 200.0d0,
     &                 (   315.0d0
     &                   - dty * sin( ALAT( j ) ) ** 2
     &                   - dthetaz * log( gpp( i, j, k ) / p0 )
     &                     * cos( ALAT( j ) ) ** 2 )
     &                       * ( gpp( i, j, k ) / p0 )**kappa )
               enddo
            enddo
         enddo

         do k = 1, KMAX
            do j = 1, JDIM
               do i = 1, IDIM
                  kt =   ka
     &                 + ( ks - ka )
     &                   * max( 0.0d0,
     &                      ( SIG ( k ) - sigb ) / ( 1.0d0 - sigb ) )
     &                       * cos( ALAT(j) ) ** 4

                  gdtphy( i, j, k ) =
     &                 - kt * ( GBT( i, j, k ) - gteq( i, j, k ) )
c$$$                  gdtphy( i, j, k ) =
c$$$     &                 - kt * ( GAT( i, j, k ) - gteq( i, j, k ) )
               enddo
            enddo
         enddo

         do k = 1, KMAX
            do j = 1, JDIM
               do i = 1, IDIM
c$$$                  GAT ( i, j, k ) = GAT ( i, j, k )
c$$$     &                 + DELT * 2.0d0 * gdtphy( i, j, k )
                  tphy ( i, j, k ) = DELT * 2.0d0 * gdtphy( i, j, k )
               enddo
            enddo
         enddo

         kf   = 1.0d0 / day

c$$$         write(*,*) 'kf=', kf
c$$$
c$$$         do k = 1, KMAX
c$$$            write(*,*) 'SIG (', k, ')=', SIG
c$$$         end do
c$$$
c$$$         do k = 1, KMAX
c$$$            write(*,*) 'SIG (', k, ') - sigb =',
c$$$     &           SIG ( k ) - sigb
c$$$         end do
c$$$         
c$$$         do k = 1, KMAX
c$$$            write(*,*) '( SIG (', k, ') - sigb ) / ( 1.0d0 - sigb ) =',
c$$$     &           ( SIG ( k ) - sigb ) / ( 1.0d0 - sigb )
c$$$         end do
c$$$
c$$$         do k = 1, KMAX
c$$$            write(*,*) 'max ( 0.0d0, ( SIG (', k,
c$$$     &           ') - sigb ) / ( 1.0d0 - sigb ) ) =',
c$$$     &           max( 0.0d0,
c$$$     &                      ( SIG ( k ) - sigb ) / ( 1.0d0 - sigb ) )
c$$$         end do
         
         do k = 1, KMAX
            do j = 1, JDIM
               do i = 1, IDIM
                  kv = kf * max( 0.0d0,
     &                      ( SIG ( k ) - sigb ) / ( 1.0d0 - sigb ) )

                  gduphy( i, j, k ) = - kv * GBU( i, j, k )
                  gdvphy( i, j, k ) = - kv * GBV( i, j, k )

c$$$                  gduphy( i, j, k ) = - kv * GAU( i, j, k )
c$$$                  gdvphy( i, j, k ) = - kv * GAV( i, j, k )
c$$$
c$$$                  write(*,*) 'kv (', i, ',', j, ',', k, ')=', 
c$$$     &                 kv
               enddo
            enddo
         enddo

c$$$         do k = 1, KMAX
c$$$            do j = 1, JDIM
c$$$               do i = 1, IDIM
c$$$                  write(*,*) 'GAU (', i, ',', j, ',', k, ')=', 
c$$$     &                 GAU ( i, j, k )
c$$$               enddo
c$$$            enddo
c$$$         enddo
c$$$
c$$$         do k = 1, KMAX
c$$$            do j = 1, JDIM
c$$$               do i = 1, IDIM
c$$$                  write(*,*) 'gduphy (', i, ',', j, ',', k, ')=', 
c$$$     &                 gduphy ( i, j, k )
c$$$               enddo
c$$$            enddo
c$$$         enddo
         
         do k = 1, KMAX
            do j = 1, JDIM
               do i = 1, IDIM
c$$$                  GAU ( i, j, k ) = GAU ( i, j, k )
c$$$     &                 + DELT * 2.0d0 * gduphy( i, j, k )
                  uphy ( i, j, k ) = DELT * 2.0d0 * gduphy( i, j, k )
c$$$                  GAV ( i, j, k ) = GAV ( i, j, k )
c$$$     &                 + DELT * 2.0d0 * gdvphy( i, j, k )
                  vphy ( i, j, k ) = DELT * 2.0d0 * gdvphy( i, j, k )
               enddo
            enddo
         enddo

         CALL DSMV2S
     O        ( WTDIV  , WTVOR  ,
     I          gduphy , gdvphy ,
     I          '    ' )

         CALL DSMS2G
     O         ( GTVOR ,
     I           WTVOR  )

         CALL DSMS2G
     O         ( GTDIV ,
     I           WTDIV  )

c$$$         CALL DSMV2S
c$$$     O        ( WADIV, WAVOR,
c$$$     I          GAU, GAV,
c$$$     I          '    ' )
c$$$
c$$$         CALL DSMS2V
c$$$     O        ( GAU, GAV,
c$$$     I          WADIV, WAVOR,
c$$$     I          '    '        )
c$$$
c$$$         CALL DSMS2G
c$$$     O         ( GAVOR ,
c$$$     I           WAVOR  )
c$$$
c$$$         CALL DSMS2G
c$$$     O         ( GADIV ,
c$$$     I           WADIV  )

*
         CALL CLCSTR ( 'DYNMCS' )
*
         CALL DYNMCS                   !" ϳعȻʬ
     M         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     M           GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     M           GAVOR , GADIV , GBVOR , GBDIV ,
     M           GTUA  , GTVA  , GTH   , GTR   ,
     I           GTVOR , GTDIV , gdtphy,
     I           ITA   , DELT  , OADVNC,
     C           ALON  , DLON  , ALAT  , DLAT  ,
     C           SIG   , SIGM  , DSIG  , DSIGM           )
*
         CALL CLCEND ( 'DYNMCS' )
*

#ifdef DEBUG
         CALL ADMXMN 
     I         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     I           GADIV , GAVOR , ITA   , 'after DYNMCS'    )
#endif
*
*"    << ADJST : ʬĴ >>
*
         CALL CLCSTR ( 'PADJST' )
*
c$$$         CALL PADJST                   !" ʪĴ
c$$$     M         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
c$$$     I           GAVOR , GADIV ,
c$$$     I           DELT*2.,
c$$$     C           SIG   , SIGM  , DSIG   , DSIGM         )
*
         CALL CLCEND ( 'PADJST' )
         CALL CLCSTR ( 'TFILT' )
*
         IF ( OADVNC ) THEN
            CALL TFILT                 !" ե륿
     M         ( GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     M           GBVOR , GBDIV ,
     I           GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     I           GAVOR , GADIV ,
     C           TFIL                                   )
         ENDIF
*
         CALL CLCEND ( 'TFILT' )
*
*"    << OUTPUT : ǡ >>
         IF ( OADVNC ) THEN
            CALL CLCSTR ( 'HISTIN' )
            CALL HISTIN ( GBU   , 'U'   ) !" ϥǡε
            CALL HISTIN ( GBV   , 'V'   )
            CALL HISTIN ( GBT   , 'T'   )
            CALL HISTIN ( GBPS  , 'PS'  )
            CALL HISTIN ( GBQ   , 'Q'   )
            CALL HISTIN ( GBVOR , 'VOR' )
            CALL HISTIN ( GBDIV , 'DIV' )
            CALL HISTIN ( GBTG  , 'TG'  )
            CALL HISTIN ( gteq  , 'gteq'  )
            CALL HISTIN ( uphy  , 'uphy'  )
            CALL HISTIN ( vphy  , 'vphy'  )
            CALL HISTIN ( tphy  , 'tphy'  )
            CALL CLCEND ( 'HISTIN' )
*
            CALL CLCSTR ( 'HISTOU' )
            CALL HISTRP
            CALL HISTOU                !" ǡ
            CALL CLCEND ( 'HISTOU' )
         ENDIF
*
*"    << NEXT : Υƥåפ >>
*
         CALL CLCSTR ( 'MISC' )
*
         CALL    ADVSTP                !" ѿʤ
     O         ( ITA   , ITB   , IDATEA, IDATEB,
     I           OADVNC                          )
*
         IF ( ORSTR ) THEN
            CALL WRRSTR                !" ꥹȥե񤭹
     I         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     I           GAVOR , GADIV ,
     I           GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     I           GBVOR , GBDIV ,
     I           ITA   , ITB   , IDATEA, IDATEB, ISTEP  )
*
            CALL WRRSTG   !" ɽꥹȡեν񤭹
     I         ( GBTG  ,
     I           ITB   , IDATEB, ISTEP  )
         ENDIF
*
         CALL CLCEND ( 'MISC' )
*
*" << LEND : ᥤ󡦥롼׽ *************> >>
*
      IF ( .NOT. ( ITB .GE. ITEND )  ) GOTO  5000
*
      CALL CLCOUT                      !" CPUֽ
      CALL YFINE                       !" ƥ
*
      STOP
      END
***********************************************************************
      SUBROUTINE AHSTRG                !" ɸʿѽϤϿ
*
*   [INTERN PARAM]
      INTEGER    ISTYPL
      DATA       ISTYPL / 1 /
      REAL       VMISS, DIVSX, DIVLX
*
      CALL GZDBGT ( 'MISS', VMISS )   !" »
*
      DIVSX = 2.5
      DIVLX = 10.
      CALL     HISTRG                  !" ϤϿ
     I       ( 'U     ', 'u-velocity          ' ,'m/s   ', 'ALEV',
     I            VMISS,  VMISS,  DIVSX,  DIVLX,  ISTYPL,
     I         ' '     , '   ' , 0     , 0     , 'X'     ,'(F12.3)' )
*
      CALL     HISTRG
     I       ( 'V     ', 'v-velocity          ' ,'m/s   ', 'ALEV',
     I            VMISS,  VMISS,  DIVSX,  DIVLX,  ISTYPL,
     I         ' '     , '   ' , 0     , 0     , 'X'     ,'(F12.3)' )
*
      CALL     HISTRG
     I       ( 'T     ', 'temperature         ' ,'K     ', 'ALEV',
     I            VMISS,  VMISS,  DIVSX,  DIVLX,  ISTYPL,
     I         ' '     , '   ' , 0     , 0     , 'X'     ,'(F12.3)' )
*
      CALL     HISTRG
     I       ( 'PS    ', 'surface pressure    ' ,'mb    ', 'ASFC',
     I            VMISS,  VMISS,  DIVSX,  DIVLX,  ISTYPL,
     I         ' '     , '   ' , 0     , 0     , 'X'     ,'(F12.3)' )
*
      CALL     HISTRG
     I       ( 'gteq  ', 'eq temperature      ' ,'K     ', 'ALEV',
     I            VMISS,  VMISS,  DIVSX,  DIVLX,  ISTYPL,
     I         '   '   , '   ' , 0     , 0     , 'X'     ,'(F12.3)' )
*
      CALL     HISTRG
     I       ( 'uphy  ', 'u tendency with hs94' ,'m/s    ', 'ALEV',
     I            VMISS,  VMISS,  DIVSX,  DIVLX,  ISTYPL,
     I         '   '   , '   ' , 0     , 0     , 'X'     ,'(F12.3)' )
*
      CALL     HISTRG
     I       ( 'vphy  ', 'v tendency with hs94' ,'m/s    ', 'ALEV',
     I            VMISS,  VMISS,  DIVSX,  DIVLX,  ISTYPL,
     I         '   '   , '   ' , 0     , 0     , 'X'     ,'(F12.3)' )
*
      CALL     HISTRG
     I       ( 'tphy  ', 't tendency with hs94' ,'K      ', 'ALEV',
     I            VMISS,  VMISS,  DIVSX,  DIVLX,  ISTYPL,
     I         '   '   , '   ' , 0     , 0     , 'X'     ,'(F12.3)' )
*
      DIVSX = 1.E-6
      DIVLX = 5.E-6
      CALL     HISTRG
     I       ( 'Q     ', 'specific humidity   ' ,'g/g   ', 'ALEV',
     I            VMISS,  VMISS,  DIVSX,  DIVLX,  ISTYPL,
     I         ' '     , '   ' , 0     , 0     , 'X'     ,'(3PF12.3)' )
*
      CALL     HISTRG
     I       ( 'VOR   ', 'vorticity           ' ,'1/s   ', 'ALEV',
     I            VMISS,  VMISS,  DIVSX,  DIVLX,  ISTYPL,
     I         '   '   , '   ' , 0     , 0     , 'X'     ,'(1PE12.3)' )
*
      CALL     HISTRG
     I       ( 'DIV   ', 'divergence          ' ,'1/s   ', 'ALEV',
     I            VMISS,  VMISS,  DIVSX,  DIVLX,  ISTYPL,
     I         '   '   , '   ' , 0     , 0     , 'X'     ,'(1PE12.3)' )
*
      DIVSX = 2.5
      DIVLX = 10.
      CALL     HISTRG
     I       ( 'TG    ', 'ground temperature  ' ,'K     ', 'ASFC',
     I            VMISS,  VMISS,  DIVSX,  DIVLX,  ISTYPL,
     I         ' '     , '   ' , 0     , 0     , 'X'     ,'(F12.3)' )
*
      RETURN
      END
*************************************************************************
      SUBROUTINE ADMXMN        !" debug monitor
     I         ( GDU   , GDV   , GDT   , GDPS  , GDQ   ,
     I           GDDIV , GDVOR , IT    , HLABEL          )
*
*   [PARAM]
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻ, ȿ
#else
#include        "zcdim.F"                    !" ʻ, ȿ
#endif
*
*   [INPUT] 
      REAL       GDU   ( IDIM, JDIM, KMAX )  !"   
      REAL       GDV   ( IDIM, JDIM, KMAX )  !"   
      REAL       GDT   ( IDIM, JDIM, KMAX )  !"   
      REAL       GDPS  ( IDIM, JDIM       )  !" ɽ
      REAL       GDQ   ( IDIM, JDIM, KMAX )  !" 漾  
      REAL       GDVOR ( IDIM, JDIM, KMAX )  !"   
      REAL       GDDIV ( IDIM, JDIM, KMAX )  !" ȯ  
      INTEGER    IT
      CHARACTER  HLABEL *(*)
*
      WRITE ( 6,* ) HLABEL, ' IT= ', IT
      CALL MAXMIN( GDU,   IDIM, JDIM, KMAX, IDIM, JDIM, 'U'   )
      CALL MAXMIN( GDV,   IDIM, JDIM, KMAX, IDIM, JDIM, 'V'   )
      CALL MAXMIN( GDT,   IDIM, JDIM, KMAX, IDIM, JDIM, 'T'   )
      CALL MAXMIN( GDPS,  IDIM, JDIM, 1,    IDIM, JDIM, 'PS'  )
      CALL MAXMIN( GDQ,   IDIM, JDIM, KMAX, IDIM, JDIM, 'Q'   )
      CALL MAXMIN( GDVOR, IDIM, JDIM, KMAX, IDIM, JDIM, 'VOR' )
      CALL MAXMIN( GDDIV, IDIM, JDIM, KMAX, IDIM, JDIM, 'DIV' )
*
      RETURN
      END
